"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Breadcrumbs = Breadcrumbs;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _locale = require("../locale");
var _themeProvider = require("../styles/theme-provider");
var _chevronRight = _interopRequireDefault(require("../icon/chevron-right"));
var _chevronLeft = _interopRequireDefault(require("../icon/chevron-left"));
var _styledComponents = require("./styled-components");
var _overrides = require("../helpers/overrides");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } /*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
function Breadcrumbs(props) {
  const {
    overrides = {},
    showTrailingSeparator = false
  } = props;
  const childrenArray = _react.Children.toArray(props.children);
  // @ts-ignore
  const childrenWithSeparators = [];
  const [Root, baseRootProps] = (0, _overrides.getOverrides)(overrides.Root, _styledComponents.StyledRoot);
  const [Right, baseIconProps] = (0, _overrides.getOverrides)(overrides.Icon, _chevronRight.default);
  const [Left] = (0, _overrides.getOverrides)(overrides.Icon, _chevronLeft.default);
  const [List, baseListProps] = (0, _overrides.getOverrides)(overrides.List, _styledComponents.StyledList);
  const [ListItem, baseListItemProps] = (0, _overrides.getOverrides)(overrides.ListItem, _styledComponents.StyledListItem);
  const [Separator, baseSeparatorProps] = (0, _overrides.getOverrides)(overrides.Separator, _styledComponents.StyledSeparator);
  baseIconProps.overrides = (0, _overrides.mergeOverrides)({
    Svg: {
      style: {
        verticalAlign: 'text-bottom'
      }
    }
  }, baseIconProps && baseIconProps.overrides);
  childrenArray.forEach((child, index) => {
    childrenWithSeparators.push(
    /*#__PURE__*/
    // @ts-ignore
    _react.default.createElement(ListItem, _extends({
      key: `breadcrumb-item-${index}`,
      $itemIndex: index
    }, baseListItemProps), child, (showTrailingSeparator || index !== childrenArray.length - 1) && /*#__PURE__*/_react.default.createElement(Separator, _extends({}, baseSeparatorProps, {
      "aria-hidden": true,
      key: `separator-${index}`
    }), /*#__PURE__*/_react.default.createElement(_themeProvider.ThemeContext.Consumer, null, theme => theme.direction === 'rtl' ? /*#__PURE__*/_react.default.createElement(Left, _extends({
      size: 16
    }, baseIconProps)) : /*#__PURE__*/_react.default.createElement(Right, _extends({
      size: 16
    }, baseIconProps))))));
  });
  return /*#__PURE__*/_react.default.createElement(_locale.LocaleContext.Consumer, null, locale => /*#__PURE__*/_react.default.createElement(Root, _extends({
    "aria-label": props['aria-label'] || props.ariaLabel || locale.breadcrumbs.ariaLabel,
    "data-baseweb": "breadcrumbs"
  }, baseRootProps), /*#__PURE__*/_react.default.createElement(List, baseListProps, childrenWithSeparators)));
}
Breadcrumbs.defaultProps = {
  overrides: {},
  showTrailingSeparator: false
};
var _default = exports.default = Breadcrumbs;