import type { Breakpoints, Theme } from '../styles';
import type { Responsive } from '../layout-grid';
import type { MediaQueryPageMargins, PageMargins } from './types';
/**
 * Helper function that generates media queries based on breakpoint, e.g.
 * getMediaQuery(720) => '@media screen and (min-width: 720px)'
 */
export declare const getMediaQuery: (breakpoint: number) => string;
export declare const getMediaQueries: (breakpoints: Breakpoints) => string[];
export declare const getMinimumPageMargins: (margins: Responsive<number>) => PageMargins;
export declare const getMediaQueryPageMargins: (theme: Theme) => MediaQueryPageMargins;
