/// <reference types="react" />
import type { Theme } from '../styles/types';
import type { StyleObject } from 'styletron-standard';
import { ADJOINED } from './constants';
import type { SharedProps, Size } from './types';
import type { SharedStyleProps } from '../textarea/types';
export declare const StyledMaskToggleButton: import("styletron-react").StyletronComponent<"button", {
    $size: Size;
    $isFocusVisible: boolean;
    $theme: Theme;
}>;
export declare const StyledClearIconContainer: import("styletron-react").StyletronComponent<"div", {
    $size: Size;
    $alignTop: boolean;
    $theme: Theme;
}>;
export declare const StyledClearIcon: import("styletron-react").StyletronComponent<import("react").ForwardRefExoticComponent<import("react").SVGAttributes<SVGElement> & {
    children?: import("react").ReactNode;
    size?: import("../icon").Size;
    color?: string;
    title?: string;
    overrides?: import("../icon").IconOverrides;
} & import("../icon").StyledComponentArgs & import("react").RefAttributes<SVGSVGElement>>, {
    $isFocusVisible: boolean;
}>;
export declare const getRootStyles: (props: {
    $adjoined: keyof typeof ADJOINED;
    $isFocused?: boolean;
    $error?: boolean;
    $disabled?: boolean;
    $positive?: boolean;
    $size: Size;
    $theme: Theme;
    $hasIconTrailing?: boolean;
}) => StyleObject;
export declare const Root: import("styletron-react").StyletronComponent<"div", SharedProps>;
export declare const InputEnhancer: import("styletron-react").StyletronComponent<"div", SharedProps>;
export declare const getInputContainerStyles: (props: {
    $isFocused?: boolean;
    $error?: boolean;
    $disabled?: boolean;
    $positive?: boolean;
    $size: Size;
    $theme: Theme;
}) => StyleObject;
export declare const InputContainer: import("styletron-react").StyletronComponent<"div", SharedProps>;
export declare const getInputStyles: (props: (SharedProps & {
    $theme: Theme;
}) | (SharedStyleProps & {
    $theme: Theme;
})) => StyleObject;
export declare const Input: import("styletron-react").StyletronComponent<"input", SharedProps>;
