import React from 'react';
import type { ReactElement, ReactNode } from 'react';
import type { Override } from '../helpers/overrides';
type SideNavigationProps = {
    activeItemId: string | null;
    children: ReactNode | undefined | null;
    overrides?: {
        List?: Override;
    };
};
export declare function SideNavigation(props: SideNavigationProps): React.JSX.Element;
type ItemProps = {
    ariaControls?: string;
    ariaExpanded?: boolean;
    active?: boolean;
    disabled?: boolean;
    endEnhancer?: ReactNode;
    href?: string;
    indent?: number;
    label: string;
    onClick?: () => void;
    overrides?: {
        Action?: Override;
        EndWrapper?: Override;
        StartEnhancerWrapper?: Override;
        StartWrapper?: Override;
    };
    startEnhancer?: ReactNode;
};
type SideNavigationHeaderProps = {
    children: ItemProps['label'];
    endEnhancer?: ItemProps['endEnhancer'];
    startEnhancer?: ItemProps['startEnhancer'];
    overrides?: ItemProps['overrides'] & {
        ListItem?: Override;
    };
};
export declare function SideNavigationHeader({ children, overrides: { ListItem, ...overrides }, ...props }: SideNavigationHeaderProps): React.JSX.Element;
type SideNavigationItemProps = {
    children: ItemProps['label'];
    disabled?: boolean;
    endEnhancer?: ItemProps['endEnhancer'];
    href?: ItemProps['href'];
    id: string;
    initiallyActive?: ItemProps['active'];
    onClick?: ItemProps['onClick'];
    overrides?: ItemProps['overrides'] & {
        ListItem?: Override;
    };
    startEnhancer?: ItemProps['startEnhancer'];
};
export declare function SideNavigationItem({ children, id, overrides: { ListItem, ...overrides }, ...props }: SideNavigationItemProps): React.JSX.Element;
type SideNavigationSectionProps = {
    active?: boolean;
    children: React.ChildrenArray<ReactElement<typeof SideNavigationItem> | ReactElement<typeof SideNavigationSection> | ReactElement<typeof SideNavigationHeader> | null>;
    forceOpen?: boolean;
    indent: number;
    overrides?: ItemProps['overrides'] & {
        List?: Override;
        ListItem?: Override;
    };
    startEnhancer?: ReactNode;
    title: string;
};
export declare function SideNavigationSection(props: SideNavigationSectionProps): React.JSX.Element;
export {};
