"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.SortableHeadCellFactory = void 0;
var React = _interopRequireWildcard(require("react"));
var _overrides = require("../helpers/overrides");
var _triangleUp = _interopRequireDefault(require("../icon/triangle-up"));
var _triangleDown = _interopRequireDefault(require("../icon/triangle-down"));
var _constants = require("./constants");
var _styledComponents = require("./styled-components");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } /*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
function SortDirectionIcon({
  direction
}) {
  switch (direction) {
    case _constants.SORT_DIRECTION.ASC:
      return /*#__PURE__*/React.createElement(_triangleUp.default, {
        title: "Sort ascending"
      });
    case _constants.SORT_DIRECTION.DESC:
      return /*#__PURE__*/React.createElement(_triangleDown.default, {
        title: "Sort descending"
      });
    default:
      return null;
  }
}
const SortableHeadCellFactory = (
// @ts-expect-error todo(flow->ts) this assignment is not correct title property is declared as ReactNode but then it is used on div element… which is not correct
CustomHeadCell = _styledComponents.StyledHeadCell) => {
  return function SortableHeadCell(props) {
    const {
      overrides = {},
      fillClickTarget,
      disabled
    } = props;
    const [HeadCell, headCellProps] = (0, _overrides.getOverrides)(overrides.HeadCell, CustomHeadCell);
    const [SortableLabel, sortableLabelProps] = (0, _overrides.getOverrides)(overrides.SortableLabel, _styledComponents.StyledSortableLabel);
    const onClick = () => {
      props.onSort && props.onSort();
    };
    const enableHeadClick = fillClickTarget && !disabled;
    let ariaLabel = props['aria-label'] || props.ariaLabel;
    if (!ariaLabel) {
      if (typeof props.title === 'string') {
        ariaLabel = `sorts table by ${props.title} column`;
      } else {
        ariaLabel = 'sort table by column';
      }
    }
    return /*#__PURE__*/React.createElement(HeadCell, _extends({
      role: "columnheader"
    }, headCellProps, {
      $cursor: enableHeadClick ? 'pointer' : undefined,
      onClick: enableHeadClick ? onClick : undefined
    }), /*#__PURE__*/React.createElement(SortableLabel, _extends({
      "aria-label": ariaLabel,
      disabled: disabled,
      onClick: !fillClickTarget ? onClick : undefined
    }, sortableLabelProps), /*#__PURE__*/React.createElement(SortDirectionIcon, {
      direction: props.direction
    }), props.title), props.children);
  };
};
exports.SortableHeadCellFactory = SortableHeadCellFactory;
var _default = exports.default = SortableHeadCellFactory();