"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFoundationColorTokenOverrides = getFoundationColorTokenOverrides;
/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/

const foundationColorTokens = ['primaryA', 'primaryB', 'primary', 'accent', 'negative', 'warning', 'positive'];
function getFoundationColorTokenOverrides(colors) {
  if (!colors) return {};
  return foundationColorTokens.reduce((acc, key) => {
    if (colors[key]) {
      acc[key] = colors[key];
    }
    return acc;
  }, {});
}